import org.junit.*;

public class MyArrayListTest{
    MyArrayList myList = new MyArrayList();


    @Test
    public void testAdd(){
        //Given
        Object obj = new Object();
        int expected = 1;
        //When
        myList.add(obj);
        int actual = myList.size();
        //Then
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void testAddAtIndex(){
        //Given
        Character a = 'a';
        Character b = 'b';
        Integer expected = 2;
        //When
        myList.add(b);
        myList.add(0,a);

        //Then
        Integer actual = myList.size();

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGet(){
        myList.add(1);
        Object actual = myList.get(0);
        Assert.assertEquals(1, actual);
    }

    @Test
    public void testRemoveAtIndex(){
        //Given
        Integer one = 1;
        myList.add(one);
        //When
        myList.remove(0);
        //Then
        Assert.assertEquals(0, myList.size());
    }

    @Test
    public void testRemoveAtObject(){
        //Given
        String mj = "It's Easy as";
        String  a = "a";
        String b = "b";
        String  c = "c";
        Integer one = 1;
        Integer two = 2;
        Integer three = 3;
        myList.add(mj);
        myList.add(a);
        myList.add(b);
        myList.add(c);
        myList.add(one);
        myList.add(two);
        myList.add(three);
        //When
        myList.remove(mj);
        //Then
        Assert.assertEquals(6,myList.size());
    }

    @Test
    public void testSet(){
        //Given
        Integer inty = 20;
        Integer inty1 = 40;
        String expected = "wub";
        //When
        myList.add(inty);
        myList.add(inty1);
        myList.add("wub");
        Object actual = myList.get(2);


        Assert.assertEquals(expected,actual);
    }

    @Test
    public void testClear(){
        //Given
        myList.add("Fill me up");
        int expected = 0;
        //When
        myList.clear();
        int actual = myList.size();
        //Then
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void testIsEmpty(){
        //When
        myList.clear();
        //Then
        Assert.assertTrue(myList.isEmpty());
    }

    @Test
    public void testIsEmptyWhenFull(){
        //Given
        Integer test = 0;
        //When
        myList.add(test);
        //Then
        Assert.assertFalse(myList.isEmpty());
    }

    @Test
    public void testContains(){
        //Given
        Boolean boolin = true;
        //When
        myList.add(boolin);
        //Then
        Assert.assertTrue(myList.contains(boolin));
    }

    @Test
    public void testContainsWhenFull(){
        //Given
        String string = "Lookin for me?";
        //Then
        Assert.assertFalse(myList.contains(string));
    }
}
