import org.junit.*;



public class MySetTest {

    MySet set;

    @Before
    public void setup(){
        set = new MySet();
    }

    @Test
    public void testAdd(){
        //Given
        Integer integer = 3;
        //When
        set.add(integer);
        //Then
        Assert.assertEquals(1,set.size());
    }

    @Test(expected = IllegalArgumentException.class)
    public void testWithDuplicate(){
        //When
        String string = "Bob";
        set.add(string);
        //When
        set.add(string);
    }
    @Test
    public void testRemove(){
        //Given
        String string = "Bob";
        set.add(string);
        //When
        set.remove(string);
        //Then
        Assert.assertTrue(set.isEmpty());
    }

    @Test
    public void testClear(){
        //Given
        set.add(new Object());
        //When
        set.clear();
        //Then
        Assert.assertTrue(set.isEmpty());
    }

    @Test
    public void testContains(){
        //When
        set.add(new Integer(1));
        //Then
        Assert.assertTrue(set.contains(1));
    }

}

